/*
 * linux/include/asm-mips/mipsconfig.h
 *
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file "COPYING" in the main directory of this archive
 * for more details.
 *
 * Copyright (C) 1994 by Waldorf Electronics
 * written by Ralf Baechle
 *
 */
#ifndef _ASM_MIPS_MIPS_CONFIG_H
#define _ASM_MIPS_MIPS_CONFIG_H

/*
 * Memory segments (32bit kernel mode addresses)
 */

#define KUSEG                   0x00000000
#define KSEG0                   0x80000000
#define KSEG1                   0xa0000000
#define KSEG2                   0xc0000000
#define KSEG3                   0xe0000000

/* returns the kernel segment base of a given address */

#define KSEGX(a)                (a & 0xe0000000)

/*
 * This is the virtual adress to which all ports are being mapped.
 */
#define PORT_BASE		0xe0000000
#define PORT_BASE_HIGH		0xe000

/*
 * This is the virtual adress to which all ports are being mapped.
 */
#define PORT_BASE		0xe0000000
#define PORT_BASE_HIGH		0xe000

/* #define NUMBER_OF_TLB_ENTRIES	48  */ /* see bootinfo.h -- Andy */
#define NUMBER_OF_TLB_ENTRIES	48

/*
 * Absolute address of the kernelstack is stored at 0x80000280
 */
#define KERNEL_SP_HIGH		0x8000
#define KERNEL_SP_LOW		0x0280

/*
 * Pagetables are 4MB mapped at 0xe3000000
 */
#define TLBMAP			0xe3000000
#define TLBMAP_HIGH		0xe300
#define TLBMAP_LOW		0x0000

/*
 * The virtual address where we'll map the pagetables
 * For a base address of 0xe3000000 this is 0xe338c000
 * FIXME: Gas misscomputes the following expression!
#define TLB_ROOT		(TLBMAP + (TLBMAP >> (12-2)))
 */
#define TLB_ROOT		0xe338c000

/*
 * This ASID is reserved for the swapper
 */
#define SWAPPER_ASID		0

#endif /* _ASM_MIPS_MIPS_CONFIG_H */
